Subject: Re: [PATCH 15/19] bootwrapper: Add initrd information to the device tree in ft_finalize().

From: David Gibson <[email-masked]>
Date: Wed, 14 Feb 2007 15:43:35 +1100

On Tue, Feb 13, 2007 at 10:07:23AM -0600, Scott Wood wrote:
> On Tue, Feb 13, 2007 at 03:29:37PM +1100, David Gibson wrote:
> > Why is cuboot's malloc() allocating the flat tree in a place that's in
> > danger of being clobbered by the kernel in the first place?
> 
> As the comment in cuboot.c explains, there's not enough room to do it any
> other way and still run on boards with only 8MiB of RAM -- the dts has to
> go above the wrapper image, and the "uncompressed" kernel has to go
> below, but the same heap is used for both.  I believe there are some 8xx
> boards out there with only this much; even if not, 8xx currently only
> maps 8MiB by default.  8xx isn't supported by this patchset, but I'd like
> to support it eventually.

Hrm, ok.  You may have seen in my Ebony patch series there's a patch
adding a bootwrapper platform_ops hook giving the address at which to
load the kernel.  At present the wrapper still decompresses the kernel
to heap-allocated space, then moves it to the specified address,
however I'm hoping to write an improved version which decompresses
directly to the final location.  That should address your problem
here, I believe.

-- 
David Gibson			| I'll have my music baroque, and my code
david AT gibson.dropbear.id.au	| minimalist, thank you.  NOT _the_ _other_
				| _way_ _around_!
http://www.ozlabs.org/~dgibson